diff --git a/src/meta/meta_ckpt.c b/src/meta/meta_ckpt.c
index 6d736b2721..b50725f4b1 100644
--- a/src/meta/meta_ckpt.c
+++ b/src/meta/meta_ckpt.c
@@ -309,6 +309,7 @@ __ckpt_set(WT_SESSION_IMPL *session, const char *fname, const char *v, bool use_
 #endif
 
         /* Concatenate the metadata base string with the checkpoint string. */
+	__wt_verbose(session, WT_VERB_BACKUP, "CKPT_SET: fname %s checkpoint string %s", fname, str);
         WT_ERR(__wt_buf_fmt(session, tmp, "%s,%s", meta_base, str));
         /*
          * Check the new metadata length is at least as long as the original metadata string with
diff --git a/test/csuite/timestamp_abort/main.c b/test/csuite/timestamp_abort/main.c
index 918255bc19..384aa7df55 100644
--- a/test/csuite/timestamp_abort/main.c
+++ b/test/csuite/timestamp_abort/main.c
@@ -118,7 +118,7 @@ extern char *__wt_optarg;
 
 #define ENV_CONFIG_DEF                                        \
     "cache_size=%" PRIu32                                     \
-    "M,create,"                                               \
+    "M,create,verbose=(backup:5),"                                               \
     "debug_mode=(table_logging=true,checkpoint_retention=5)," \
     "eviction_updates_target=20,eviction_updates_trigger=90," \
     "log=(enabled,file_max=10M,remove=true),session_max=%d,"  \
@@ -407,6 +407,7 @@ backup_create_full(WT_CONNECTION *conn, bool consolidate, uint32_t index)
 
     printf("Create full backup %" PRIu32 " - start: consolidate=%d, granularity=%" PRIu32 "KB\n",
       index, consolidate, backup_granularity_kb);
+    fflush(stdout);
 
     /* Prepare the directory. */
     testutil_check(__wt_snprintf(backup_home, sizeof(backup_home), BACKUP_BASE "%" PRIu32, index));
@@ -443,6 +444,7 @@ backup_create_full(WT_CONNECTION *conn, bool consolidate, uint32_t index)
     testutil_assert_errno(fclose(fp) == 0);
 
     printf("Create full backup %" PRIu32 " - complete: files=%" PRId32 "\n", index, nfiles);
+    fflush(stdout);
 }
 
 /*
@@ -472,12 +474,15 @@ backup_create_incremental(WT_CONNECTION *conn, uint32_t src_index, uint32_t inde
       __wt_snprintf(src_backup_home, sizeof(src_backup_home), BACKUP_BASE "%" PRIu32, src_index));
 
     printf("Create incremental backup %" PRIu32 " - start: source=%" PRIu32 "\n", index, src_index);
+    fflush(stdout);
 
+#if 0
     /* Verify the source backup in the case it might be already corrupted. */
     if (backup_verify_throughout) {
         testutil_check(__wt_snprintf(buf, sizeof(buf), "ID%" PRIu32, src_index));
         testutil_verify_src_backup(conn, src_backup_home, WT_HOME_DIR, buf);
     }
+#endif
 
     /* Prepare the directory. */
     testutil_check(__wt_snprintf(backup_home, sizeof(backup_home), BACKUP_BASE "%" PRIu32, index));
@@ -575,11 +580,15 @@ backup_create_incremental(WT_CONNECTION *conn, uint32_t src_index, uint32_t inde
     printf("Create incremental backup %" PRIu32 " - complete: files=%" PRId32 ", ranges=%" PRId32
            ", unmodified=%" PRId32 "\n",
       index, nfiles, nranges, nunmodified);
+    fflush(stdout);
 
     /* Immediately verify the backup. */
     if (backup_verify_throughout) {
-        testutil_check(__wt_snprintf(buf, sizeof(buf), "ID%" PRIu32, index));
-        testutil_verify_src_backup(conn, backup_home, WT_HOME_DIR, buf);
+        printf("==== backup_create_incremental: Recover and verify index %" PRIu32 "\n", index);
+        fflush(stdout);
+        testutil_check(recover_and_verify(index, 0));
+        printf("==== DONE: backup_create_incremental: Recover and verify index %" PRIu32 "\n", index);
+        fflush(stdout);
     }
 }
 
@@ -680,6 +689,8 @@ thread_ckpt_run(void *arg)
         /*
          * Since this is the default, send in this string even if running without timestamps.
          */
+        printf("Checkpoint %d start: Flush: %s.\n", i, flush_tier ? "YES" : "NO");
+        fflush(stdout);
         testutil_check(session->checkpoint(session, flush_tier ? ckpt_flush_config : ckpt_config));
         testutil_check(td->conn->query_timestamp(td->conn, ts_string, "get=last_checkpoint"));
         testutil_assert(sscanf(ts_string, "%" SCNx64, &stable) == 1);
@@ -1077,6 +1088,8 @@ run_workload(uint32_t workload_iteration)
     if (!opts->compat && !opts->inmem)
         strcat(envconf, ENV_CONFIG_ADD_EVICT_DIRTY);
 
+    fflush(stdout);
+    fflush(stderr);
     testutil_wiredtiger_open(opts, WT_HOME_DIR, envconf, NULL, &conn, false, false);
     testutil_check(conn->open_session(conn, NULL, NULL, &session));
 
@@ -1270,13 +1283,20 @@ backup_verify(WT_CONNECTION *conn, uint32_t workload_iteration)
                       __wt_snprintf(backup_id, sizeof(backup_id), "ID%" PRIu32, index));
                     printf("==== Verify ID %s dir %s against backup source ====\n", backup_id,
                       dir->d_name);
+	            fflush(stdout);
                     testutil_verify_src_backup(conn, dir->d_name, WT_HOME_DIR, backup_id);
                     printf("==== DONE Verify ID %s dir %s against backup source ====\n", backup_id,
                       dir->d_name);
+	            fflush(stdout);
                 }
-            } else
+            } else {
                 /* Perform a full test. */
+                printf("==== Backup_verify: Recover and verify index %" PRIu32 "\n", index);
+	        fflush(stdout);
                 testutil_check(recover_and_verify(index, workload_iteration));
+                printf("==== DONE: Backup_verify: Recover and verify index %" PRIu32 "\n", index);
+	        fflush(stdout);
+           }
         }
     }
     testutil_check(closedir(d));
@@ -1316,14 +1336,18 @@ recover_and_verify(uint32_t backup_index, uint32_t workload_iteration)
      * Open the connection which forces recovery to be run.
      */
     if (backup_index == 0) {
+	fflush(stdout);
+	fflush(stderr);
         testutil_wiredtiger_open(opts, WT_HOME_DIR, NULL, &my_event, &conn, true, false);
         printf("Connection open and recovery complete. Verify content\n");
         /* Compare against the copy of the home directory just before recovery. */
         if (use_backups) {
             printf("==== Verify saved dir against backup source ====\n");
+	    fflush(stdout);
             testutil_check(__wt_snprintf(buf, sizeof(buf), "%s.SAVE/%s", home, WT_HOME_DIR));
             testutil_verify_src_backup(conn, buf, WT_HOME_DIR, NULL);
             printf("==== DONE Verify saved dir against backup source ====\n");
+	    fflush(stdout);
         }
         /*
          * Only call this when index is 0 because it calls back into here to verify a specific
@@ -1341,6 +1365,8 @@ recover_and_verify(uint32_t backup_index, uint32_t workload_iteration)
          * create it would cause the test to abort as we currently allow only one statistics thread
          * at a time.
          */
+	fflush(stdout);
+	fflush(stderr);
         testutil_wiredtiger_open(opts, buf, NULL, NULL, &conn, true, false);
     }
 
@@ -1604,9 +1630,9 @@ main(int argc, char *argv[])
     memset(opts, 0, sizeof(*opts));
 
     backup_full_interval = 4;
-    backup_granularity_kb = 16;
+    backup_granularity_kb = 1024;
     backup_verify_quick = false;
-    backup_verify_throughout = false;
+    backup_verify_throughout = true;
     columns = stress = false;
     nth = MIN_TH;
     num_iterations = 1;